#!/bin/sh

NOTEBOOKTOOL="/var/packages/NoteStation/target/tools/synonsnotebook"
NOTETOOL="/var/packages/NoteStation/target/tools/synonsnote"
TAGTOOL="/var/packages/NoteStation/target/tools/synonstag"
SHORTCUTTOOL="/var/packages/NoteStation/target/tools/synonsshortcut"
FTSTOOL="/var/packages/NoteStation/target/tools/synonsfts"

USER1=1024
USER2=1026
USER3=1031

echo "Do you want to clear exist note/notebook in pgsql database? [y/N]"
read ANS
if [ "x$ANS" = "xY" -o "x$ANS" = "xy" ];then
    /usr/bin/psql -U postgres synodrive -c "DELETE FROM object WHERE ns='NoteStation';"
    /usr/bin/psql -U postgres notestation -c "DELETE FROM note;"
    /usr/bin/psql -U postgres notestation -c "DELETE FROM notebook;"
    rm /var/packages/NoteStation/target/db/fts.db
    $FTSTOOL --init
fi

#######################################################################
#Add book 1 and 3 notes

TEMP=$($NOTEBOOKTOOL --create requester=$USER1 title=book_1)
NB=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)

TEMP=$($NOTETOOL --create requester=$USER1 title=note_1_3)
NOTE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE parent_id=$NB tag=[\"tag1\"] ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER1 title=note_1_2)
NOTE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE parent_id=$NB tag=[\"tag2\"] ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER1 title=note_1_1)
NOTE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE parent_id=$NB tag=[\"tag1\",\"tag3\"] ver=$VERSION

#######################################################################
#Add book 2 and 3 notes

TEMP=$($NOTEBOOKTOOL --create requester=$USER1 title=book_2)
NB2=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)

TEMP=$($NOTETOOL --create requester=$USER1 title=note_2_3)
NOTE2=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE2 parent_id=$NB2 tag=[\"tag1\"] ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER1 title=note_2_2)
NOTE2=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE2 parent_id=$NB2 tag=[\"tag2\"] ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER1 title=note_2_1)
NOTE2=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE2 parent_id=$NB2 tag=[\"tag1\",\"tag3\"] ver=$VERSION

#######################################################################
#Add book 3 and 3 notes

TEMP=$($NOTEBOOKTOOL --create requester=$USER1 title=book_3)
NB3=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)

TEMP=$($NOTETOOL --create requester=$USER1 title=note_3_3)
NOTE3=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE3 parent_id=$NB3 tag=[\"tag1\"] ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER1 title=note_3_2)
NOTE3=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE3 parent_id=$NB3 tag=[\"tag2\"] ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER1 title=note_3_1)
NOTE3=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE3 parent_id=$NB3 tag=[\"tag1\",\"tag3\"] ver=$VERSION

#######################################################################
#Add 3 recycled notes

TEMP=$($NOTETOOL --create requester=$USER1 title=note_recycle_3)
NOTE_RECYCLE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE_RECYCLE recycle=1 ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER1 title=note_recycle_2)
NOTE_RECYCLE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE_RECYCLE recycle=1 ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER1 title=note_recycle_1)
NOTE_RECYCLE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE_RECYCLE recycle=1 ver=$VERSION

#######################################################################
#Add shared book and notes share to user1

TEMP=$($NOTEBOOKTOOL --create requester=$USER1 title=book_4_to_user2)
NB4=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)

TEMP=$($NOTETOOL --create requester=$USER1 title=note_4_3)
NOTE4=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE4 parent_id=$NB4 ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER1 title=note_4_2)
NOTE4=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE4 parent_id=$NB4 ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER1 title=note_4_1_to_user2)
NOTE4=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER1 object_id=$NOTE4 parent_id=$NB4 ver=$VERSION

synodriveobject --set ns=NoteStation id=$NB4 acl={\"enabled\":true,\"dsm_user\":{\"${USER2}\":{\"name\":\"admin\",\"specified\":true,\"perm\":\"rw\"}}}
synodriveobject --set ns=NoteStation id=$NOTE4 acl={\"enabled\":true,\"dsm_user\":{\"${USER2}\":{\"name\":\"admin\",\"specified\":true,\"perm\":\"rw\"}}}

sleep 1

TEMP=$($NOTETOOL --create requester=$USER1 title=note_4_to_user2)
NOTE4=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)

sleep 1

synodriveobject --set ns=NoteStation id=$NOTE4 acl={\"enabled\":true,\"dsm_user\":{\"${USER2}\":{\"name\":\"admin\",\"specified\":true,\"perm\":\"rw\"}}}
#######################################################################
#Add shared book and notes from user2

TEMP=$($NOTEBOOKTOOL --create requester=$USER2 title=book_a_from_user2)
NB_SHARE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)

TEMP=$($NOTETOOL --create requester=$USER2 title=note_a_3_from_user2)
NOTE_SHARE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER2 object_id=$NOTE_SHARE parent_id=$NB_SHARE ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER2 title=note_a_2_from_user2)
NOTE_SHARE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER2 object_id=$NOTE_SHARE parent_id=$NB_SHARE ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER2 title=note_a_1_from_user2)
NOTE_SHARE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER2 object_id=$NOTE_SHARE parent_id=$NB_SHARE ver=$VERSION

synodriveobject --set ns=NoteStation id=$NB_SHARE acl={\"enabled\":true,\"dsm_user\":{\"${USER1}\":{\"name\":\"admin\",\"specified\":true,\"perm\":\"rw\"}}}
synodriveobject --set ns=NoteStation id=$NOTE_SHARE acl={\"enabled\":true,\"dsm_user\":{\"${USER1}\":{\"name\":\"admin\",\"specified\":true,\"perm\":\"rw\"}}}

sleep 1

TEMP=$($NOTETOOL --create requester=$USER2 title=note_x_from_user2)
NOTE_SHARE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)

sleep 1

synodriveobject --set ns=NoteStation id=$NOTE_SHARE acl={\"enabled\":true,\"dsm_user\":{\"${USER1}\":{\"name\":\"admin\",\"specified\":true,\"perm\":\"rw\"}}}

#######################################################################
#Add shared book and notes from user3

TEMP=$($NOTEBOOKTOOL --create requester=$USER3 title=book_b_from_user3)
NB_SHARE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)

TEMP=$($NOTETOOL --create requester=$USER3 title=note_b_3_from_user3)
NOTE_SHARE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER3 object_id=$NOTE_SHARE parent_id=$NB_SHARE ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER3 title=note_b_2_from_user3)
NOTE_SHARE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER3 object_id=$NOTE_SHARE parent_id=$NB_SHARE ver=$VERSION

TEMP=$($NOTETOOL --create requester=$USER3 title=note_b_1_from_user3)
NOTE_SHARE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)
VERSION=$(echo $TEMP | awk '{print $2}' | sed 's/version=//'g)
sleep 1
$NOTETOOL --set requester=$USER3 object_id=$NOTE_SHARE parent_id=$NB_SHARE ver=$VERSION

synodriveobject --set ns=NoteStation id=$NB_SHARE acl={\"enabled\":true,\"dsm_user\":{\"${USER1}\":{\"name\":\"admin\",\"specified\":true,\"perm\":\"rw\"}}}
synodriveobject --set ns=NoteStation id=$NOTE_SHARE acl={\"enabled\":true,\"dsm_user\":{\"${USER1}\":{\"name\":\"admin\",\"specified\":true,\"perm\":\"rw\"}}}

sleep 1

TEMP=$($NOTETOOL --create requester=$USER3 title=note_y_from_user3)
NOTE_SHARE=$(echo $TEMP | awk '{print $1}' | sed 's/id=//'g)

sleep 1

synodriveobject --set ns=NoteStation id=$NOTE_SHARE acl={\"enabled\":true,\"dsm_user\":{\"${USER1}\":{\"name\":\"admin\",\"specified\":true,\"perm\":\"rw\"}}}


#######################################################################
#Add shortcut

sleep 1
$SHORTCUTTOOL --set requester=$USER1 object_id=$NB
sleep 1
$SHORTCUTTOOL --set requester=$USER1 object_id=$NOTE
sleep 1
$SHORTCUTTOOL --set requester=$USER1 object_id=$NB2
sleep 1
$SHORTCUTTOOL --set requester=$USER1 object_id=$NOTE2
sleep 1
$SHORTCUTTOOL --set requester=$USER1 object_id=$NB4
sleep 1
$SHORTCUTTOOL --set requester=$USER1 object_id=$NOTE4
sleep 1
$SHORTCUTTOOL --set requester=$USER1 object_id=$NB_SHARE
sleep 1
$SHORTCUTTOOL --set requester=$USER1 object_id=$NOTE_SHARE
sleep 1
$SHORTCUTTOOL --set requester=$USER1 tag_id=tag1@${USER1}
sleep 1
$SHORTCUTTOOL --set requester=$USER1 tag_id=tag2@${USER1}
echo "done"

#######################################################################

